package monitor;

/** A binary semaphore.
 *  TBD. Ensure the queue is fair. 
 *  */
public class BinarySemaphore
{
    boolean acquired ;
    
    public BinarySemaphore( boolean initial_state ) {
        acquired = initial_state ; }
    
    /** The P operation */
    public synchronized void acquire() {
        while( acquired ) {
            try {wait() ; }
            catch( InterruptedException e ) {} }
        acquired = true ;
    }
    
    /** The V operation */
    public synchronized void release() {
        acquired = false ;
        notify() ; }
}